/*
Copyright (c) 2003, Shiv Kaushal, University of Manchester
All rights reserved.

 Redistribution and use in source and binary forms, with or
 without modification, are permitted provided that the following
 conditions are met:

  o Redistributions of source code must retain the above
  copyright notice, this list of conditions and the following
  disclaimer.
  o Redistributions in binary form must reproduce the above
  copyright notice, this list of conditions and the following
  disclaimer in the documentation and/or other materials
  provided with the distribution.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND
   CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
   INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
   MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
   DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
   BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
   EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
   TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
   ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
   OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
   OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
   POSSIBILITY OF SUCH DAMAGE.
*/

/*---------------------------------------------------------------------------*
* This program is part of GridSite: http://www.gridpp.ac.uk/authz/gridsite/ *
*---------------------------------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>
#include <gridsite.h>
#include <gridsite-gacl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>

extern char *grst_perm_syms[];
extern int grst_perm_vals[];

#include "grst_admin.h"

/*CGI GACL - Edit interface functions*/
/*
void show_acl(int admin, GRSTgaclUser *user, char *dn, GRSTgaclPerm perm, char *help_uri, char *dir_path, char *file, char *dir_uri, char *admin_file);
void new_entry_form(GRSTgaclUser *user, char *dn, GRSTgaclPerm perm, char *help_uri, char *dir_path, char *file, char *dir_uri, char *admin_file);
void new_entry(GRSTgaclUser *user, char *dn, GRSTgaclPerm perm, char *help_uri, char *dir_path, char *file, char *dir_uri, char *admin_file);
void del_entry(GRSTgaclUser *user, char *dn, GRSTgaclPerm perm, char *help_uri, char *dir_path, char *file, char *dir_uri, char *admin_file);
void edit_entry_form(GRSTgaclUser *user, char *dn, GRSTgaclPerm perm, char *help_uri, char *dir_path, char *file, char *dir_uri, char *admin_file);
void edit_entry(GRSTgaclUser *user, char *dn, GRSTgaclPerm perm, char *help_uri, char *dir_path, char *file, char *dir_uri, char *admin_file);
void add_cred_form(GRSTgaclUser *user, char *dn, GRSTgaclPerm perm, char *help_uri, char *dir_path, char *file, char *dir_uri, char *admin_file);
void add_cred(GRSTgaclUser *user, char *dn, GRSTgaclPerm perm, char *help_uri, char *dir_path, char *file, char *dir_uri, char *admin_file);
void del_cred(GRSTgaclUser *user, char *dn, GRSTgaclPerm perm, char *help_uri, char *dir_path, char *file, char *dir_uri, char *admin_file);
void del_entry_sure(GRSTgaclUser *user, char *dn, GRSTgaclPerm perm, char *help_uri, char *dir_path, char *file, char *dir_uri, char *admin_file);
void del_cred_sure(GRSTgaclUser *user, char *dn, GRSTgaclPerm perm, char *help_uri, char *dir_path, char *file, char *dir_uri, char *admin_file);
*/

/*Functions producing messages*/
//void error(char *dn, GRSTgaclPerm perm, char *help_uri, char *dir_path, char *file, char *dir_uri, char *admin_file);
/*
void admin_continue(char *dn, GRSTgaclPerm perm, char *help_uri, char *dir_path, char *file, char *dir_uri, char *admin_file, GRSThttpBody *bp);
*/


/*ACL functions*/
int GACLentriesInAcl(GRSTgaclAcl *acl);
int GRSTgaclCredsInEntry(GRSTgaclEntry *entry);
void GACLeditGetPerms(GRSTgaclEntry *entry);
GRSTgaclEntry *GACLreturnEntry(GRSTgaclAcl *acl, int entry_no);
GRSTgaclCred *GACLreturnCred(GRSTgaclEntry *entry, int cred_no);

void GRSTgaclCredTableStart(GRSThttpBody *bp){

  GRSThttpPrintf (bp,"<table border=\"1\" cellpadding=\"2\" cellspacing=\"0\" style=\"border-collapse: collapse\" bordercolor=\"#111111\" width=\"100%\" id=\"CredentialTable\">");
  //GRSThttpPrintf (bp,"<tr><td align=center width=\"10%\"><b>Credential No.</td><td align=center width=\"10%\"><b>Type</td><td align=center width=\"10%\"><b>Descriptor</td><td align=left width=\"70%\"><b>Value</td></tr>");
  GRSThttpPrintf (bp,"<tr><td align=center width=\"10%\"><b>Credential No.</td><td align=center width=\"15%\"><b>Type</td><td align=left width=\"75%\"><b>Value</td></tr>");

}

void GRSTgaclCredTableAdd(GRSTgaclEntry *entry, GRSTgaclCred *cred, GRSTgaclNamevalue *namevalue, int cred_no, int entry_no, int admin, int timestamp, GRSThttpBody *bp, char *dn, GRSTgaclPerm perm, char *help_uri, char *dir_path, char *file, char *dir_uri, char *admin_file){

  char* cmd = GRSThttpGetCGI("cmd");
  int edit_values=0, new_cred=0, allow_new_person=1;
  GRSTgaclUser *user;
  GRSTgaclCred *test_cred;
  char *p;

  if (strcmp(cmd, "new_entry_form")==0 || strcmp(cmd, "add_cred_form")==0) new_cred=1;
  if (new_cred || strcmp(cmd, "edit_entry_form")==0) edit_values=1;

  if (new_cred) { /*Print out type and descriptor*/
     if (strcmp(cmd, "add_cred_form")==0){ /*if not a new entry check to see if <person> cred exists.*/
       cred=entry->firstcred;
       while (cred!=NULL) {if (strcmp (cred->type, "person")==0) allow_new_person=0; cred=cred->next;}
     }
     /*create dummy credential for the user to edit*/
     cred=GRSTgaclCredNew("new");
     GRSTgaclCredAddValue(cred, "", "change me");
     namevalue=cred->firstname;
     /*Drop down list of types*/
     GRSThttpPrintf(bp,"<tr><td align=center >New</td>");
     GRSThttpPrintf(bp,"<td align=center >");
     GRSThttpPrintf (bp, " <select size=\"1\" name=\"type\">\n");
     GRSThttpPrintf (bp, " <option selected value=\"not_chosen\">(choose)</option>\n");
     if (allow_new_person) GRSThttpPrintf (bp, " <option value=\"person\">Person &lt;dn&gt; &lt;/dn&gt;</option>\n");
     GRSThttpPrintf (bp, " <option value=\"dn-list\">DN-List &lt;url&gt; &lt;/url&gt;</option>\n");
     GRSThttpPrintf (bp, " <option value=\"dns\">DNS &lt;hostname&gt; &lt;/hostname&gt;</option>\n");
     GRSThttpPrintf (bp, " <option value=\"voms\">VOMS &lt;fqan&gt; &lt;/fqan&gt;</option>\n");
     if (strcmp(cmd, "new_entry_form")==0) GRSThttpPrintf (bp, " <option value=\"any-user\">Any User</option>\n");
     GRSThttpPrintf (bp, " </select></td>");
   }

  else { /*Print out type and descriptor*/

    GRSThttpPrintf(bp,"<tr><td align=center >%d", cred_no);
    if (admin) GRSThttpPrintf (bp,"<a href=\"%s%s?diruri=%s&cmd=del_cred_sure&entry_no=%d&cred_no=%d&timestamp=%d\">(Delete)</a>", dir_uri,admin_file,dir_uri, entry_no, cred_no, timestamp);
    GRSThttpPrintf(bp, "</td>");

    GRSThttpPrintf(bp,"<td align=center >%s ", cred->type);
  }

  if (strcmp(cred->type, "any-user")==0) { /*Blank after 'type'*/ GRSThttpPrintf (bp, "</td><td>&nbsp;");}

  else{


  //GRSThttpPrintf(bp, "&lt;%s&gt; &lt;/%s&gt;</td>", namevalue->name,namevalue->name);

  if (edit_values){
    GRSThttpPrintf (bp, "<td align=left><input type=\"text\" name=\"cred%d_value\"\n", cred_no);
    GRSThttpPrintf (bp, "size=\"50\" value=\"%s\">", namevalue->value);
  }

  else GRSThttpPrintf(bp, "<td align=left >%s", namevalue->value);

   

  if (dn != NULL)
    {
      test_cred = GRSTgaclCredNew("person");
      GRSTgaclCredAddValue(test_cred, "dn", dn);
      user = GRSTgaclUserNew(test_cred);
    }

  p = getenv("REMOTE_HOST");
  if (p != NULL)
    {
      test_cred = GRSTgaclCredNew("dns");
      GRSTgaclCredAddValue(test_cred, "hostname", p);

      if (user == NULL) user = GRSTgaclUserNew(test_cred);
      else              GRSTgaclUserAddCred(user, test_cred);
    }

  }

  if ( GRSTgaclUserHasCred(user, cred)  )  GRSThttpPrintf(bp, "<font color=red><b>&nbsp;&#191;?</b></font>");

  GRSThttpPrintf(bp, "</td></tr>");

}

void GRSTgaclCredTableEnd(GRSTgaclEntry* entry, int entry_no, int admin, int timestamp, GRSThttpBody *bp, char *dn, GRSTgaclPerm perm, char *help_uri, char *dir_path, char *file, char *dir_uri, char *admin_file){

  int i, blank_perms, edit_perms, show_perms;
  char* cmd = GRSThttpGetCGI("cmd");

  if (strcmp(cmd, "add_cred_form")==0 ||strcmp(cmd, "del_cred_sure")==0) show_perms=0; else show_perms=1;
  if (strcmp(cmd, "edit_entry_form")==0 || strcmp(cmd, "new_entry_form")==0) edit_perms=1; else edit_perms=0;
  if (strcmp(cmd, "new_entry_form")==0) blank_perms=1; else blank_perms=0;

  if (show_perms==0){GRSThttpPrintf (bp,"</table><br>\n"); return;}

  GRSThttpPrintf (bp,"<tr><td align=center>");

  if (admin) GRSThttpPrintf (bp,"<a href=\"%s%s?diruri=%s&cmd=add_cred_form&entry_no=%d&timestamp=%d\">Add&nbsp;Credential</a>", dir_uri,admin_file,dir_uri, entry_no, timestamp);
  //GRSThttpPrintf (bp, "</td>\n<td align=center width=\"10%\"></td><td align=center width=\"10%\"></td><td align=left width=\"70%\">");
  GRSThttpPrintf (bp, "</td>\n<td>&nbsp;</td><td align=left>");

  if (blank_perms) entry->allowed=entry->denied=GRST_PERM_NONE;

  /*Permissions*/
  GRSThttpPrintf (bp, "<b>Allowed:</b>  ");
  for (i=0; grst_perm_syms[i]!=NULL; i++)  /* Print the list of allowed permissions*/
  {
    if ( entry->allowed & grst_perm_vals[i]){
      if (edit_perms) GRSThttpPrintf (bp, "%s<input type=\"checkbox\" name=\"allow_%s\" value=\"ON\" checked>&nbsp;&nbsp;&nbsp;\n", grst_perm_syms[i],grst_perm_syms[i]);
      else GRSThttpPrintf(bp,"%s ", grst_perm_syms[i]); if (strcmp(grst_perm_syms[i], "none")==0) break;
    }
    else if (strcmp(grst_perm_syms[i], "none")!=0) if (edit_perms) GRSThttpPrintf (bp, "%s<input type=\"checkbox\" name=\"allow_%s\" value=\"ON\" unchecked>&nbsp;&nbsp;&nbsp;\n", grst_perm_syms[i],grst_perm_syms[i]);
  }

  if (edit_perms) GRSThttpPrintf (bp, "<p>");
  GRSThttpPrintf (bp, "<b>Denied:&nbsp;</b>");
  for (i=0; grst_perm_syms[i]!=NULL; i++)  /* Print the list of denied permissions*/
  {
   if  ( entry->denied & grst_perm_vals[i])
   {
     if (edit_perms) GRSThttpPrintf (bp, "%s<input type=\"checkbox\" name=\"deny_%s\" value=\"ON\" checked>&nbsp;&nbsp;&nbsp;\n", grst_perm_syms[i],grst_perm_syms[i]);
     else GRSThttpPrintf(bp,"%s ", grst_perm_syms[i]);

     if (strcmp(grst_perm_syms[i], "none")==0) break;
   }
   else if (strcmp(grst_perm_syms[i], "none")!=0) if (edit_perms) GRSThttpPrintf (bp, "%s<input type=\"checkbox\" name=\"deny_%s\" value=\"ON\" unchecked>&nbsp;&nbsp;&nbsp;\n", grst_perm_syms[i],grst_perm_syms[i]);
  }

  GRSThttpPrintf (bp, "</td></tr>");
  GRSThttpPrintf (bp,"</table><br>\n");
  GRSThttpPrintf (bp,"\n");

}

int check_acl_save(char *dn, GRSTgaclPerm perm, char *help_uri, char *dir_path, char *file, char *dir_uri, char *admin_file, GRSTgaclUser* user, GRSTgaclAcl *acl, GRSThttpBody *bp)
{

  struct stat file_info;
  GRSTgaclPerm new_perm;

  /*Check ACL has not been modified*/
  stat(GRSTgaclFileFindAclname(dir_path), &file_info);
  if (atol(GRSThttpGetCGI("timestamp"))!=file_info.st_mtime){
    GRSThttpPrintf (bp, "ERROR: CANNOT SAVE CHANGES<p><p> The ACL has been modified since it was last viewed\n<p>");
    admin_continue(dn, perm, help_uri, dir_path, file, dir_uri, admin_file, bp);
    GRSThttpPrintHeaderFooter(bp, dir_path, GRST_FOOTFILE);
    GRSThttpWriteOut(bp);
    return 0;
  }

  // check users permissions in the new ACL
  new_perm = GRSTgaclAclTestUser(acl, user);

if (new_perm != perm){
  //Check that user still has Admin permissions - if not then exit without saving the new ACL
  if (!GRSTgaclPermHasAdmin(new_perm)){
    GRSThttpPrintf (bp, "ERROR: CANNOT SAVE CHANGES\n\n<p><p> You cannot deny yourself admin access from within the editor\n");
    admin_continue(dn, perm, help_uri, dir_path, file, dir_uri, admin_file, bp);
    GRSThttpPrintHeaderFooter(bp, dir_path, GRST_FOOTFILE);
    GRSThttpWriteOut(bp);
    return 0;
  }
  //Functions to inform of other permission changes come next
  GRSThttpPrintf (bp, "WARNING: OPERATION CHANGED YOUR PERMISSIONS!\n\n<p><p> You still have Admin permissions<p>\n");

}

  // ACL not modified, notified of permission changes - can now save
  GRSTgaclAclSave(acl, GRSTgaclFileFindAclname(dir_path));

  return 1;
}


/*****************************************/
/********** FUNCTIONS FOLLOW *************/
/*****************************************/

void show_acl(int admin, GRSTgaclUser *user, char *dn, GRSTgaclPerm perm,
              char *help_uri, char *dir_path,
              char *file, char *dir_uri, char *admin_file)/* Shows the contents of the ACL. Gives edit 'buttons' if (int admin) == 1*/
{
  GRSTgaclAcl *acl;
  GRSTgaclEntry *entry;
  GRSTgaclCred *cred;
  GRSTgaclNamevalue *namevalue;
  int entry_no, cred_no, allow, deny,timestamp;
  GRSThttpBody bp;
  char* AclFilename;
  struct stat file_info;

  /*double-check access permision*/
  if (!GRSTgaclPermHasAdmin(perm)) admin=0;

  /*Start HTML output*/
  printf("Status: 200 OK\nContent-Type: text/html\n");
  GRSThttpBodyInit(&bp);
  GRSThttpPrintf(&bp, "<title>Access Control List for %s</title>\n", dir_uri);
  GRSThttpPrintHeaderFooter(&bp, dir_path, GRST_HEADFILE);

  /* Load ACL from file and get timestamp*/
  AclFilename=GRSTgaclFileFindAclname(dir_path);
  stat(AclFilename, &file_info);
  timestamp=file_info.st_mtime;
  acl = GRSTgaclAclLoadFile(AclFilename);

  if (acl==NULL)
  {
    GRSThttpPrintf ( &bp,"The ACL was not found !!!<br>\n");

    GRSThttpPrintHeaderFooter(&bp, dir_path, GRST_FOOTFILE);
    GRSThttpWriteOut(&bp);

    return;
  }

  if (admin) GRSThttpPrintf (&bp,"<a href=\"%s%s?cmd=new_entry_form&diruri=%s&timestamp=%d\">New&nbsp;Entry</a>", dir_uri, admin_file, dir_uri, timestamp );

  GRSThttpPrintf (&bp, "<br>\n");

  /*Start with the first entry in the list and work through*/
  entry=acl->firstentry;
  entry_no=1;
  while (entry!=NULL)
  {

    GRSThttpPrintf (&bp,"<br>Entry %d:\n", entry_no);
    if (admin) GRSThttpPrintf (&bp,"<a href=\"%s%s?cmd=edit_entry_form&entry_no=%d&diruri=%s&timestamp=%d\">Edit&nbsp;Entry</a> ",
      dir_uri, admin_file, entry_no, dir_uri, timestamp );
    if (admin) GRSThttpPrintf (&bp,"<a href=\"%s%s?cmd=del_entry_sure&entry_no=%d&diruri=%s&timestamp=%d\">Delete&nbsp;Entry</a> ",
      dir_uri, admin_file, entry_no, dir_uri, timestamp );
    GRSThttpPrintf (&bp,"<p>\n");

    /*Start with the first credential in the entry and work through*/
    cred=entry->firstcred;
    cred_no=1;
    GRSTgaclCredTableStart(&bp);

    while (cred!=NULL)
    {
      /*Start with the first namevalue in the credential*/
      namevalue=cred->firstname;

      GRSTgaclCredTableAdd(entry, cred, namevalue, cred_no, entry_no, admin, timestamp, &bp, dn, perm, help_uri, dir_path, file, dir_uri, admin_file);

      /*Change to next credential*/
      cred=cred->next;
      cred_no++;
    }

    GRSTgaclCredTableEnd (entry, entry_no, admin, timestamp, &bp, dn, perm, help_uri, dir_path, file, dir_uri, admin_file);

    /*Change to next entry*/
    entry=entry->next;
    entry_no++;
  }

  if (!admin&&GRSTgaclPermHasAdmin(perm)) GRSThttpPrintf (&bp,"<a href=\"%s%s?cmd=admin_acl&diruri=%s&timestamp=%d\">Admin&nbsp;Mode</a>",  dir_uri, admin_file, dir_uri, timestamp );

  GRSThttpPrintHeaderFooter(&bp, dir_path, GRST_FOOTFILE); GRSThttpWriteOut(&bp); return;
}


void new_entry_form(GRSTgaclUser *user, char *dn, GRSTgaclPerm perm,
                    char *help_uri, char *dir_path,
                    char *file, char *dir_uri, char *admin_file) /*Presents the user with a form asking for details required to create a new entry*/
{
  GRSThttpBody bp;
  int timestamp=atol(GRSThttpGetCGI("timestamp"));
  GRSTgaclCred* cred;
  GRSTgaclEntry *entry;
  GRSTgaclNamevalue* namevalue;
  /*Start HTML output*/
  printf("Status: 200 OK\nContent-Type: text/html\n");
  GRSThttpBodyInit(&bp);
  GRSThttpPrintf(&bp, "<title>Access Control List for %s</title>\n", dir_uri);
  GRSThttpPrintHeaderFooter(&bp, dir_path, GRST_HEADFILE);

  GRSThttpPrintf (&bp, "<form method=\"POST\" action=\"%s%s?diruri=%s\">\n", dir_uri, admin_file, dir_uri);
  GRSThttpPrintf (&bp, " <font size=\"4\"><b>NEW ENTRY IN ACL FOR %s </b></font></p>\n", dir_uri);
  GRSThttpPrintf (&bp, " <input type=\"hidden\" name=\"cmd\" value=\"new_entry\">\n");
  GRSThttpPrintf (&bp, " <input type=\"hidden\" name=\"timestamp\" value=\"%d\">\n", timestamp);

  GRSTgaclCredTableStart(&bp);

  GRSTgaclCredTableAdd(entry,cred, namevalue, 0, 0, 0, timestamp, &bp, dn, perm, help_uri, dir_path, file, dir_uri, admin_file);

  GRSTgaclCredTableEnd (entry, 0, 0, timestamp, &bp, dn, perm, help_uri, dir_path, file, dir_uri, admin_file);

  /*Submit and reset buttons -  submit button sends the data in the form back to the script & new_entry() to be called*/
  GRSThttpPrintf (&bp, " <br><input type=\"submit\" value=\"Submit\" name=\"B1\"><input type=\"reset\" value=\"Reset\" name=\"B2\"></p>\n");
  GRSThttpPrintf (&bp, "</form>\n");

  GRSThttpPrintHeaderFooter(&bp, dir_path, GRST_FOOTFILE); GRSThttpWriteOut(&bp); return;
}

void new_entry(GRSTgaclUser *user, char *dn, GRSTgaclPerm perm,
               char *help_uri, char *dir_path,
               char *file, char *dir_uri, char *admin_file) /*Processes the information entered into the form from new_entry_form() and andds a new entry to th ACL*/
{
  GRSTgaclAcl *acl;
  GRSTgaclEntry *entry;
  GRSTgaclCred *cred;
  char *type, *value;
  GRSThttpBody bp;

  /*Start HTML output*/
  printf("Status: 200 OK\nContent-Type: text/html\n");
  GRSThttpBodyInit(&bp);
  GRSThttpPrintf(&bp, "<title>Access Control List for %s</title>\n", dir_uri);
  GRSThttpPrintHeaderFooter(&bp, dir_path, GRST_HEADFILE);

  /*Get the credential details and perform check*/
  type=GRSThttpGetCGI("type");
  if (strcmp(type, "not_chosen")==0){ GRSThttpPrintf (&bp, "ERROR: credential type not chosen!"); admin_continue(dn, perm, help_uri, dir_path, file, dir_uri, admin_file, &bp); GRSThttpPrintHeaderFooter(&bp, dir_path, GRST_FOOTFILE); GRSThttpWriteOut(&bp); return; }
  value=GRSThttpGetCGI("cred0_value");

  /*Create the credential*/
  cred=GRSTgaclCredNew(type);
  if (strcmp(type, "person")==0) GRSTgaclCredAddValue(cred,"dn", value);
  else if (strcmp(type, "dn-list")==0) GRSTgaclCredAddValue(cred, "url", value);
  else if (strcmp(type, "voms")==0) GRSTgaclCredAddValue(cred, "fqan", value);
  else if (strcmp(type, "dns")==0) GRSTgaclCredAddValue(cred, "hostname", value);

  /*Create and empty entry, add the credential and get permissions*/
  entry = GRSTgaclEntryNew();
  //  entry = GACLnewEntry();
  GRSTgaclEntryAddCred(entry, cred);
  GACLeditGetPerms(entry);

  /*Load the ACL, add the entry and save*/
  acl = GRSTgaclAclLoadFile(GRSTgaclFileFindAclname(dir_path));
  GRSTgaclAclAddEntry(acl, entry);

  if (!check_acl_save(dn, perm, help_uri, dir_path, file, dir_uri, admin_file, user, acl, &bp)) return;

  GRSThttpPrintf (&bp, "New entry added\n");
  admin_continue(dn, perm, help_uri, dir_path, file, dir_uri, admin_file, &bp);
              ;
  GRSThttpPrintHeaderFooter(&bp, dir_path, GRST_FOOTFILE); GRSThttpWriteOut(&bp); return;
}


void del_entry(GRSTgaclUser *user, char *dn, GRSTgaclPerm perm,
               char *help_uri, char *dir_path,
               char *file, char *dir_uri, char *admin_file)/*Deletes the entry denoted by the GCI variable "entry_no"*/
{

  int entry_no;
  GRSTgaclAcl *acl;
  //GRSTgaclEntry *previous, *entry;
  GRSTgaclEntry *previous, *entry;
  GRSThttpBody bp;
  
  /*Start HTML output*/
  printf("Status: 200 OK\nContent-Type: text/html\n");
  GRSThttpBodyInit(&bp);
  GRSThttpPrintf(&bp, "<title>Access Control List for %s</title>\n", dir_uri);
  GRSThttpPrintHeaderFooter(&bp, dir_path, GRST_HEADFILE);


  /*Load the ACL*/
  acl = GRSTgaclAclLoadFile(GRSTgaclFileFindAclname(dir_path));

  /* Get the number of the entry to be deleted and check okay to delete*/
  entry_no=atol(GRSThttpGetCGI("entry_no"));
  if(GACLentriesInAcl(acl)<=1)
  {
    GRSThttpPrintf (&bp, "ERROR: Cannot delete all entries from the ACL<br>");
    admin_continue(dn, perm, help_uri, dir_path, file, dir_uri, admin_file, &bp);
    GRSThttpPrintHeaderFooter(&bp, dir_path, GRST_FOOTFILE); GRSThttpWriteOut(&bp); return;
  }

  /*Get pointer to entry and previous entry*/
  entry = GACLreturnEntry(acl, entry_no);
  if (entry_no!=1) previous = GACLreturnEntry(acl, entry_no-1);

  if(entry==NULL || entry_no<1 || entry_no>GACLentriesInAcl(acl) )
  {
    GRSThttpPrintf (&bp, "ERROR: Entry does not exist>");
    admin_continue(dn, perm, help_uri, dir_path, file, dir_uri, admin_file, &bp);
    GRSThttpPrintHeaderFooter(&bp, dir_path, GRST_FOOTFILE); GRSThttpWriteOut(&bp); return;
  }

  /* Perform deletion from the list by changing pointers and freeing memory */
  if (entry_no==1) acl->firstentry=entry->next;
  else if (entry_no==GACLentriesInAcl(acl)) previous->next=NULL;
  else previous->next=entry->next;
  //GRSTgaclEntryFree(entry);

  if (!check_acl_save(dn, perm, help_uri, dir_path, file, dir_uri, admin_file, user, acl, &bp)) return;

  GRSThttpPrintf (&bp, "entry %d deleted\n", entry_no);
  admin_continue(dn, perm, help_uri, dir_path, file, dir_uri, admin_file, &bp);

  GRSThttpPrintHeaderFooter(&bp, dir_path, GRST_FOOTFILE); GRSThttpWriteOut(&bp); return;
}


void edit_entry_form(GRSTgaclUser *user, char *dn, GRSTgaclPerm perm,
                     char *help_uri, char *dir_path,
                     char *file, char *dir_uri, char *admin_file)/*Presents the user with an editable form containing details of entry denoted by CGI variable entry_no*/
{
  int entry_no, cred_no, i, admin=0, timestamp=atol(GRSThttpGetCGI("timestamp"));
  GRSTgaclAcl *acl;
  GRSTgaclEntry *entry;
  GRSTgaclCred *cred;
  GRSTgaclNamevalue *namevalue;
  //  struct _GACLnamevalue *namevalue;
  GRSThttpBody bp;

  /*Start HTML output*/
  printf("Status: 200 OK\nContent-Type: text/html\n");
  GRSThttpBodyInit(&bp);
  GRSThttpPrintf(&bp, "<title>Access Control List for %s</title>\n", dir_uri);
  GRSThttpPrintHeaderFooter(&bp, dir_path, GRST_HEADFILE);


  /*Load ACL from file*/
  acl = GRSTgaclAclLoadFile(GRSTgaclFileFindAclname(dir_path));

  /*Get pointer to the entry and check okay*/
  entry_no=atol(GRSThttpGetCGI("entry_no"));
  entry = GACLreturnEntry(acl, entry_no);
  if(entry==NULL || entry_no<1 || entry_no>GACLentriesInAcl(acl) )
  {
    GRSThttpPrintf (&bp, "ERROR: Entry does not exist>");
    admin_continue(dn, perm, help_uri, dir_path, file, dir_uri, admin_file, &bp);
    GRSThttpPrintHeaderFooter(&bp, dir_path, GRST_FOOTFILE); GRSThttpWriteOut(&bp); return;
  }

  /* Enter hidden data needed by the script */
  GRSThttpPrintf (&bp, "<form method=\"POST\" action=\"%s%s?diruri=%s&timestamp=%d\">\n", dir_uri, admin_file, dir_uri, timestamp);
  GRSThttpPrintf (&bp, "<b><font size=\"4\">EDITING ENTRY %d IN ACL FOR %s </font></b></p>\n", entry_no, dir_uri);
  GRSThttpPrintf (&bp, "<input type=\"hidden\" name=\"cmd\" value=\"edit_entry\">\n");
  GRSThttpPrintf (&bp, "<input type=\"hidden\" name=\"entry_no\" value=\"%d\">\n", entry_no);

  /* Start with first credential in the entry and display them in order*/
  cred=entry->firstcred;
  cred_no=1;

GRSTgaclCredTableStart(&bp);

    while (cred!=NULL)
    {
      /*Start with the first namevalue in the credential*/
      namevalue=cred->firstname;
      

      GRSTgaclCredTableAdd(entry, cred, namevalue, cred_no, entry_no, admin, timestamp, &bp, dn, perm, help_uri, dir_path, file, dir_uri, admin_file);

      /*Change to next credential*/
      cred=cred->next;
      cred_no++;
    }

    GRSTgaclCredTableEnd (entry, entry_no, admin, timestamp, &bp, dn, perm, help_uri, dir_path, file, dir_uri, admin_file);


  /*Submit and reset buttons -  submit button sends the data in the form back to the script & edit_entry() to be called*/
  GRSThttpPrintf (&bp, "<br><input type=\"submit\" value=\"Submit\" name=\"B1\"><input type=\"reset\" value=\"Reset\" name=\"B2\"></p>\n");
  GRSThttpPrintf (&bp, "</form>");

  GRSThttpPrintHeaderFooter(&bp, dir_path, GRST_FOOTFILE); GRSThttpWriteOut(&bp); return;
}


void edit_entry(GRSTgaclUser *user, char *dn, GRSTgaclPerm perm,
                char *help_uri, char *dir_path,
                char *file, char *dir_uri, char *admin_file) /*Processes the information entered into the form from edit_entry_form() and updates the entry corresponding to entry_no*/
{
  int entry_no, cred_no, i;
  GRSTgaclAcl *acl;
  GRSTgaclEntry *entry;
  GRSTgaclCred *cred;
  GRSTgaclNamevalue *namevalue;
  char variable[30];
  GRSThttpBody bp;

  /*Start HTML output*/
  printf("Status: 200 OK\nContent-Type: text/html\n");
  GRSThttpBodyInit(&bp);
  GRSThttpPrintf(&bp, "<title>Access Control List for %s</title>\n", dir_uri);
  GRSThttpPrintHeaderFooter(&bp, dir_path, GRST_HEADFILE);


  /*Load the ACL*/
  acl = GRSTgaclAclLoadFile(GRSTgaclFileFindAclname(dir_path));

  /*Get pointer to the entry and perform checks */
  entry_no=atol(GRSThttpGetCGI("entry_no"));
  entry = GACLreturnEntry(acl, entry_no);
  if(entry==NULL || entry_no<1 || entry_no>GACLentriesInAcl(acl) ){
    GRSThttpPrintf (&bp, "ERROR: Entry does not exist>");
    admin_continue(dn, perm, help_uri, dir_path, file, dir_uri, admin_file, &bp);
    GRSThttpPrintHeaderFooter(&bp, dir_path, GRST_FOOTFILE); GRSThttpWriteOut(&bp); return;
  }

  /*Start with the first credential and update*/
  cred=entry->firstcred;
  cred_no=1;

  while (cred!=NULL)
  {
    /*Start with the first namevalue*/
    namevalue=cred->firstname;
    sprintf(variable, "cred%d_value", cred_no);
    namevalue->value=GRSThttpGetCGI(variable);

    /*Change to next credential*/
    cred=cred->next;
    cred_no++;

  }

  /*Update permissions*/
  GACLeditGetPerms(entry);

  if (!check_acl_save(dn, perm, help_uri, dir_path, file, dir_uri, admin_file, user, acl, &bp)) return;
  
  GRSThttpPrintf (&bp, "entry %s updated\n", GRSThttpGetCGI("entry_no"));
  admin_continue(dn, perm, help_uri, dir_path, file, dir_uri, admin_file, &bp);

  GRSThttpPrintHeaderFooter(&bp, dir_path, GRST_FOOTFILE); GRSThttpWriteOut(&bp); return;
}


void add_cred_form(GRSTgaclUser *user, char *dn, GRSTgaclPerm perm,
                   char *help_uri, char *dir_path,
                   char *file, char *dir_uri, char *admin_file) /*Presents the user with a form asking for details required to create a new credential in the entry denoted by entry_no*/
{
  GRSThttpBody bp;
  int timestamp=atol(GRSThttpGetCGI("timestamp")), entry_no=atol(GRSThttpGetCGI("entry_no"));
  GRSTgaclAcl *acl;
  GRSTgaclEntry* entry;
  GRSTgaclCred* cred;
  GRSTgaclNamevalue* namevalue;


  /*Start HTML output*/
  printf("Status: 200 OK\nContent-Type: text/html\n");
  GRSThttpBodyInit(&bp);
  GRSThttpPrintf(&bp, "<title>Access Control List for %s</title>\n", dir_uri);
  GRSThttpPrintHeaderFooter(&bp, dir_path, GRST_HEADFILE);

   /*Load the ACL*/
  acl = GRSTgaclAclLoadFile(GRSTgaclFileFindAclname(dir_path));

  /*Get pointer to the entry  and perform checks*/
  entry = GACLreturnEntry(acl, entry_no);

  if(entry==NULL || entry_no<1 || entry_no>GACLentriesInAcl(acl) )
  {
    GRSThttpPrintf (&bp, "ERROR: Entry does not exist>");
    admin_continue(dn, perm, help_uri, dir_path, file, dir_uri, admin_file, &bp);
    GRSThttpPrintHeaderFooter(&bp, dir_path, GRST_FOOTFILE); GRSThttpWriteOut(&bp); return;
  }

  if (strcmp(GRSThttpGetCGI("cmd"), "add_cred_form")==0){ /*if not a new entry check to see if <person> cred exists.*/
       cred=entry->firstcred;
       while (cred!=NULL) {
         if (strcmp (cred->type, "any-user")==0) {
	   GRSThttpPrintf (&bp, "ERROR: AND-ing \"any-user\" credential with other credential does not make sense <p>\n");
          admin_continue(dn, perm, help_uri, dir_path, file, dir_uri, admin_file, &bp);
          GRSThttpPrintHeaderFooter(&bp, dir_path, GRST_FOOTFILE); GRSThttpWriteOut(&bp); 
 	  return;
	  }
	  cred=cred->next;
       }
  }


  GRSThttpPrintf (&bp, "<form method=\"POST\" action=\"%s%s?diruri=%s\">\n", dir_uri, admin_file, dir_uri);
  GRSThttpPrintf (&bp, " <font size=\"4\"><b>NEW CREDENTIAL IN ENTRY %d OF ACL FOR %s</font></p>\n", entry_no, dir_uri);
  GRSThttpPrintf (&bp, " <input type=\"hidden\" name=\"cmd\" value=\"add_cred\">\n");
  GRSThttpPrintf (&bp, " <input type=\"hidden\" name=\"entry_no\" value=\"%d\">\n", entry_no);
  GRSThttpPrintf (&bp, " <input type=\"hidden\" name=\"timestamp\" value=\"%d\">\n", timestamp);

  GRSTgaclCredTableStart(&bp);
  GRSTgaclCredTableAdd(entry, cred, namevalue, 0, 0, 0, timestamp, &bp, dn, perm, help_uri, dir_path, file, dir_uri, admin_file);
  GRSTgaclCredTableEnd (entry, 0, 0, timestamp, &bp, dn, perm, help_uri, dir_path, file, dir_uri, admin_file);

  /*Submit and reset buttons -  submit button sends the data in the form back to the script & add_cred() to be called*/
  GRSThttpPrintf (&bp, " <br><input type=\"submit\" value=\"Submit\" name=\"B1\"><input type=\"reset\" value=\"Reset\" name=\"B2\"></p>\n");
  GRSThttpPrintf (&bp, "</form>\n");

  GRSThttpPrintHeaderFooter(&bp, dir_path, GRST_FOOTFILE); GRSThttpWriteOut(&bp); return;
}


void add_cred(GRSTgaclUser *user, char *dn, GRSTgaclPerm perm,
              char *help_uri, char *dir_path,
              char *file, char *dir_uri, char *admin_file) /*Processes the information entered into the form [add_cred_form()]and adds a new credential to the entry corresponding to entry_no*/
{
  int entry_no;
  GRSTgaclAcl *acl;
  GRSTgaclEntry *entry;
  GRSTgaclCred *cred;
  GRSThttpBody bp;

  /*Start HTML output*/
  printf("Status: 200 OK\nContent-Type: text/html\n");
  GRSThttpBodyInit(&bp);
  GRSThttpPrintf(&bp, "<title>Access Control List for %s</title>\n", dir_uri);
  GRSThttpPrintHeaderFooter(&bp, dir_path, GRST_HEADFILE);


  /*Load the ACL*/
  acl = GRSTgaclAclLoadFile(GRSTgaclFileFindAclname(dir_path));

  /*Get pointer to the entry  and perform checks*/
  entry_no=atol(GRSThttpGetCGI("entry_no"));
  entry = GACLreturnEntry(acl, entry_no);
  if(entry==NULL || entry_no<1 || entry_no>GACLentriesInAcl(acl) )
  {
    GRSThttpPrintf (&bp, "ERROR: Entry does not exist>");
    admin_continue(dn, perm, help_uri, dir_path, file, dir_uri, admin_file, &bp);
    GRSThttpPrintHeaderFooter(&bp, dir_path, GRST_FOOTFILE); GRSThttpWriteOut(&bp); return;
  }

  /*create new credential and add it to entry*/
  cred=GRSTgaclCredNew(GRSThttpGetCGI("type"));
  if (strcmp(GRSThttpGetCGI("type"), "person")==0) GRSTgaclCredAddValue(cred,"dn", GRSThttpGetCGI("cred0_value"));
  else if (strcmp(GRSThttpGetCGI("type"), "dn-list")==0) GRSTgaclCredAddValue(cred, "url", GRSThttpGetCGI("cred0_value"));
  else if (strcmp(GRSThttpGetCGI("type"), "voms")==0) GRSTgaclCredAddValue(cred, "fqan", GRSThttpGetCGI("cred0_value"));
  else if (strcmp(GRSThttpGetCGI("type"), "dns")==0) GRSTgaclCredAddValue(cred, "hostname", GRSThttpGetCGI("cred0_value"));
  else{
    GRSThttpPrintf (&bp, "ERROR: Invalid input to script\n\n ");
    admin_continue(dn, perm, help_uri, dir_path, file, dir_uri, admin_file, &bp);
    GRSThttpPrintHeaderFooter(&bp, dir_path, GRST_FOOTFILE);
    GRSThttpWriteOut(&bp);
    return;
  }
  GRSTgaclEntryAddCred(entry, cred);

  if (!check_acl_save(dn, perm, help_uri, dir_path, file, dir_uri, admin_file, user, acl, &bp)) return;
  
  GRSThttpPrintf (&bp, "New credential added\n");
  admin_continue(dn, perm, help_uri, dir_path, file, dir_uri, admin_file, &bp);

  GRSThttpPrintHeaderFooter(&bp, dir_path, GRST_FOOTFILE); GRSThttpWriteOut(&bp); return;
}


void del_cred(GRSTgaclUser *user, char *dn, GRSTgaclPerm perm,
              char *help_uri, char *dir_path,
              char *file, char *dir_uri, char *admin_file) /*Deletes the credential denoted by the GCI variable "cred_no", in the entry denoted by "entry_no"*/
{
  int entry_no, cred_no;
  GRSTgaclAcl *acl;
  GRSTgaclEntry *entry;
  GRSTgaclCred *previous, *cred;
  GRSThttpBody bp;

  /*Start HTML output*/
  printf("Status: 200 OK\nContent-Type: text/html\n");
  GRSThttpBodyInit(&bp);
  GRSThttpPrintf(&bp, "<title>Access Control List for %s</title>\n", dir_uri);
  GRSThttpPrintHeaderFooter(&bp, dir_path, GRST_HEADFILE);


  acl = GRSTgaclAclLoadFile(GRSTgaclFileFindAclname(dir_path));

  /* Get pointer to the entry and perform checks*/
  entry_no=atol(GRSThttpGetCGI("entry_no"));
  entry = GACLreturnEntry(acl, entry_no);
  if(entry==NULL || entry_no<1 || entry_no>GACLentriesInAcl(acl) )
  {
    GRSThttpPrintf (&bp, "ERROR: Entry does not exist>");
    admin_continue(dn, perm, help_uri, dir_path, file, dir_uri, admin_file, &bp);
    GRSThttpPrintHeaderFooter(&bp, dir_path, GRST_FOOTFILE); GRSThttpWriteOut(&bp); return;
  }
  /* Get pointer the the credential and perform checks*/
  cred_no=atol(GRSThttpGetCGI("cred_no"));
  if(GRSTgaclCredsInEntry(entry)<=1)
  {
    GRSThttpPrintf (&bp, "ERROR: Cannot delete all credentials from the entry<br>");
    admin_continue(dn, perm, help_uri, dir_path, file, dir_uri, admin_file, &bp);
    GRSThttpPrintHeaderFooter(&bp, dir_path, GRST_FOOTFILE); GRSThttpWriteOut(&bp); return;
  }

  cred=GACLreturnCred(entry, cred_no);
  if(entry==NULL || entry_no<1 || cred_no>GRSTgaclCredsInEntry(entry)){
    GRSThttpPrintf (&bp, "ERROR: Credential does not exist>");
    admin_continue(dn, perm, help_uri, dir_path, file, dir_uri, admin_file, &bp);
    GRSThttpPrintHeaderFooter(&bp, dir_path, GRST_FOOTFILE); GRSThttpWriteOut(&bp); return;
  }

  /*Get pointer to previous credential - if needed*/
  if (cred_no!=1) previous = GACLreturnCred(entry, cred_no-1);

  /* Perform deletion from the list by changing pointers and freeing memory */
  if (cred_no==1) entry->firstcred=cred->next;
  else if (cred_no==GRSTgaclCredsInEntry(entry)) previous->next=NULL;
  else previous->next=cred->next;
  GRSTgaclCredFree(cred);


  if (!check_acl_save(dn, perm, help_uri, dir_path, file, dir_uri, admin_file, user, acl, &bp)) return;
  GRSThttpPrintf (&bp, "credential %s deleted from entry %s\n", GRSThttpGetCGI("cred_no"), GRSThttpGetCGI("entry_no"));
  admin_continue(dn, perm, help_uri, dir_path, file, dir_uri, admin_file, &bp);

  GRSThttpPrintHeaderFooter(&bp, dir_path, GRST_FOOTFILE); GRSThttpWriteOut(&bp); return;
}

void admin_continue(char *dn, GRSTgaclPerm perm,
                    char *help_uri, char *dir_path,
                    char *file, char *dir_uri, char *admin_file, GRSThttpBody *bp)/*Single line printed out to forward users back to show_acl in admin mode*/
{
  /* ALWAYS called from another function so no HTML header required*/
  GRSThttpPrintf (bp, "\n<br><a href=\"%s%s?diruri=%s&cmd=admin_acl&timestamp=%d\">Click&nbsp;Here</a> to return to the editor", dir_uri,admin_file,dir_uri, time(NULL));

  return;
}


void del_entry_sure(GRSTgaclUser *user, char *dn, GRSTgaclPerm perm, char *help_uri, char *dir_path, char *file, char *dir_uri, char *admin_file)
{
  GRSTgaclAcl *acl;
  GRSTgaclEntry *entry;
  GRSTgaclCred *cred;
  GRSTgaclNamevalue *namevalue;
  int entry_no, cred_no, allow, deny, i, timestamp;
  GRSThttpBody bp;

  /*Start HTML output*/
  printf("Status: 200 OK\nContent-Type: text/html\n");
  GRSThttpBodyInit(&bp);
  GRSThttpPrintf(&bp, "<title>Access Control List for %s</title>\n", dir_uri);
  GRSThttpPrintHeaderFooter(&bp, dir_path, GRST_HEADFILE);

  GRSThttpPrintf (&bp, "<h1 align=center>Do you really want to delete the following entry?</h1><br><br>");

  /* Load ACL from file */
  acl = GRSTgaclAclLoadFile(GRSTgaclFileFindAclname(dir_path));

  if (acl==NULL)
  {
    GRSThttpPrintf ( &bp,"The ACL was not found !!!<br>\n");
    admin_continue(dn, perm, help_uri, dir_path, file, dir_uri, admin_file, &bp);
    GRSThttpPrintHeaderFooter(&bp, dir_path, GRST_FOOTFILE);
    GRSThttpWriteOut(&bp);
    return;

  }

  /*Get pointer to the entry and check okay*/
  entry_no=atol(GRSThttpGetCGI("entry_no"));
  entry = GACLreturnEntry(acl, entry_no);
  if(entry==NULL || entry_no<1 || entry_no>GACLentriesInAcl(acl) )
  {
    GRSThttpPrintf (&bp, "ERROR: Entry does not exist>");
    admin_continue(dn, perm, help_uri, dir_path, file, dir_uri, admin_file, &bp);
    GRSThttpPrintHeaderFooter(&bp, dir_path, GRST_FOOTFILE); GRSThttpWriteOut(&bp); return;
  }

  GRSThttpPrintf (&bp,"<br>Entry %d:\n", entry_no);
  GRSThttpPrintf (&bp,"<br>\n");

  /*Print the entry out*/
  /*Start with the first credential in the entry and work through*/
  cred=entry->firstcred;
  cred_no=1;

  GRSTgaclCredTableStart(&bp);

    while (cred!=NULL)
    {
      /*Start with the first namevalue in the credential*/
      namevalue=cred->firstname;

      GRSTgaclCredTableAdd(entry, cred, namevalue, cred_no, entry_no, 0, 0, &bp, dn, perm, help_uri, dir_path, file, dir_uri, admin_file);

      /*Change to next credential*/
      cred=cred->next;
      cred_no++;
    }

    GRSTgaclCredTableEnd (entry, entry_no, 0, 0, &bp, dn, perm, help_uri, dir_path, file, dir_uri, admin_file);


  /*Yes Button*/
  timestamp=atol(GRSThttpGetCGI("timestamp"));
  GRSThttpPrintf (&bp, "<form method=\"POST\" action=\"%s%s?diruri=%s&cmd=del_entry&entry_no=%d&timestamp=%d\">\n", dir_uri, admin_file, dir_uri, entry_no, timestamp);
  GRSThttpPrintf (&bp, " <p align=center><input type=\"submit\" value=\"Yes\" name=\"B1\"></p>\n");
  GRSThttpPrintf (&bp, "</form>\n");

  admin_continue(dn, perm, help_uri, dir_path, file, dir_uri, admin_file, &bp);


  GRSThttpPrintHeaderFooter(&bp, dir_path, GRST_FOOTFILE); GRSThttpWriteOut(&bp);

  return;

}
void del_cred_sure(GRSTgaclUser *user, char *dn, GRSTgaclPerm perm, char *help_uri, char *dir_path, char *file, char *dir_uri, char *admin_file){

  GRSTgaclAcl *acl;
  GRSTgaclEntry *entry;
  GRSTgaclCred *cred;
  GRSTgaclNamevalue *namevalue;
  int entry_no, cred_no, allow, deny, timestamp, i;
  GRSThttpBody bp;

  /*Start HTML output*/
  printf("Status: 200 OK\nContent-Type: text/html\n");
  GRSThttpBodyInit(&bp);
  GRSThttpPrintf(&bp, "<title>Access Control List for %s</title>\n", dir_uri);
  GRSThttpPrintHeaderFooter(&bp, dir_path, GRST_HEADFILE);

  /* Load ACL from file */
  acl = GRSTgaclAclLoadFile(GRSTgaclFileFindAclname(dir_path));

  if (acl==NULL)
  {
    GRSThttpPrintf ( &bp,"The ACL was not found !!!<br>\n");
    admin_continue(dn, perm, help_uri, dir_path, file, dir_uri, admin_file, &bp);
    GRSThttpPrintHeaderFooter(&bp, dir_path, GRST_FOOTFILE);
    GRSThttpWriteOut(&bp);
    return;

  }

  /*Get pointer to the entry and check okay*/
  entry_no=atol(GRSThttpGetCGI("entry_no"));
  entry = GACLreturnEntry(acl, entry_no);
  if(entry==NULL || entry_no<1 || entry_no>GACLentriesInAcl(acl) )
  {
    GRSThttpPrintf (&bp, "ERROR: Entry does not exist>");
    admin_continue(dn, perm, help_uri, dir_path, file, dir_uri, admin_file, &bp);
    GRSThttpPrintHeaderFooter(&bp, dir_path, GRST_FOOTFILE); GRSThttpWriteOut(&bp); return;
  }

  /*Print the entry out*/
  /*Start with the first credential in the entry and work through*/
  cred_no=atol(GRSThttpGetCGI("cred_no"));

  if(GRSTgaclCredsInEntry(entry)<=1)
  {
    GRSThttpPrintf (&bp, "ERROR: Cannot delete all credentials from the entry<br>");
    admin_continue(dn, perm, help_uri, dir_path, file, dir_uri, admin_file, &bp);
    GRSThttpPrintHeaderFooter(&bp, dir_path, GRST_FOOTFILE); GRSThttpWriteOut(&bp); return;
  }

  cred=GACLreturnCred(entry, cred_no);
  if(entry==NULL || entry_no<1 || cred_no>GRSTgaclCredsInEntry(entry)){
    GRSThttpPrintf (&bp, "ERROR: Credential does not exist>");
    admin_continue(dn, perm, help_uri, dir_path, file, dir_uri, admin_file, &bp);
    GRSThttpPrintHeaderFooter(&bp, dir_path, GRST_FOOTFILE); GRSThttpWriteOut(&bp); return;
  }

  GRSThttpPrintf (&bp, "<h1 align=center>Do you really want to delete the following credential from entry %d?</h1><br><br>", entry_no);


  GRSTgaclCredTableStart(&bp);
      
  GRSTgaclCredTableAdd(entry, cred, cred->firstname, cred_no, entry_no, 0, 0, &bp, dn, perm, help_uri, dir_path, file, dir_uri, admin_file);

  GRSTgaclCredTableEnd (entry, entry_no, 0, 0, &bp, dn, perm, help_uri, dir_path, file, dir_uri, admin_file);

  GRSThttpPrintf (&bp,"<br>\n");

  /*Yes Button*/
  timestamp=atol(GRSThttpGetCGI("timestamp"));
  GRSThttpPrintf (&bp, "<form method=\"POST\" action=\"%s%s?diruri=%s&cmd=del_cred&entry_no=%d&cred_no=%d&timestamp=%d\">\n", dir_uri, admin_file, dir_uri, entry_no, cred_no,timestamp);
  GRSThttpPrintf (&bp, " <p align=center><input type=\"submit\" value=\"Yes\" name=\"B1\"></p>\n");
  GRSThttpPrintf (&bp, "</form>\n");

  admin_continue(dn, perm, help_uri, dir_path, file, dir_uri, admin_file, &bp);


  GRSThttpPrintHeaderFooter(&bp, dir_path, GRST_FOOTFILE); GRSThttpWriteOut(&bp);

  return;

}



int GACLentriesInAcl(GRSTgaclAcl *acl) /*Returns the number of entries in acl*/
{
  GRSTgaclEntry *entry;
  int number;

  entry=acl->firstentry;
  number=0;

  while (entry!=NULL)
  {
    number++;
    entry=entry->next;
  }

  return number;
}


int GRSTgaclCredsInEntry(GRSTgaclEntry *entry) /*Returns the number of credentials in entry*/
{
  int number;
  GRSTgaclCred *cred;

  cred=entry->firstcred;
  number=0;

  while (cred!=NULL)
  {
    number++;
    cred=cred->next;
  }

  return number;
}


void GACLeditGetPerms(GRSTgaclEntry *entry) /*Updates the permissions entry using permissions from a form*/
{
  /*update allowed*/
  if (strcmp (GRSThttpGetCGI("allow_read"), "ON") == 0 )  GRSTgaclEntryAllowPerm(entry, GRST_PERM_READ);  else GRSTgaclEntryUnallowPerm(entry, GRST_PERM_READ);
  if (strcmp (GRSThttpGetCGI("allow_write"), "ON") == 0 ) GRSTgaclEntryAllowPerm(entry, GRST_PERM_WRITE); else GRSTgaclEntryUnallowPerm(entry, GRST_PERM_WRITE);
  if (strcmp (GRSThttpGetCGI("allow_list"), "ON") == 0 )  GRSTgaclEntryAllowPerm(entry, GRST_PERM_LIST);  else GRSTgaclEntryUnallowPerm(entry, GRST_PERM_LIST);
  if (strcmp (GRSThttpGetCGI("allow_admin"), "ON") == 0 ) GRSTgaclEntryAllowPerm(entry, GRST_PERM_ADMIN); else GRSTgaclEntryUnallowPerm(entry, GRST_PERM_ADMIN);

  /*update denied*/
  if (strcmp (GRSThttpGetCGI("deny_read"), "ON") == 0 )  GRSTgaclEntryDenyPerm(entry, GRST_PERM_READ);  else GRSTgaclEntryUndenyPerm(entry, GRST_PERM_READ);
  if (strcmp (GRSThttpGetCGI("deny_write"), "ON") == 0 ) GRSTgaclEntryDenyPerm(entry, GRST_PERM_WRITE); else GRSTgaclEntryUndenyPerm(entry, GRST_PERM_WRITE);
  if (strcmp (GRSThttpGetCGI("deny_list"), "ON") == 0 )  GRSTgaclEntryDenyPerm(entry, GRST_PERM_LIST);  else GRSTgaclEntryUndenyPerm(entry, GRST_PERM_LIST);
  if (strcmp (GRSThttpGetCGI("deny_admin"), "ON") == 0 ) GRSTgaclEntryDenyPerm(entry, GRST_PERM_ADMIN); else GRSTgaclEntryUndenyPerm(entry, GRST_PERM_ADMIN);

  return;
}

GRSTgaclEntry *GACLreturnEntry(GRSTgaclAcl *acl, int entry_no) /*returns a pointer to entry in ACL denoted by entry_no, returns NULL if not found*/
{
  int number;
  GRSTgaclEntry *entry;

  entry=acl->firstentry;
  number=1;

  while (entry!=NULL)
  {
    if (number==entry_no) return entry;
    number++;
    entry=entry->next;
  }

  return NULL;
}


GRSTgaclCred *GACLreturnCred(GRSTgaclEntry *entry, int cred_no)/*returns a pointer to credential denoted by cred_no in entry, returns NULL if not found*/
{
  int number;
  GRSTgaclCred *cred;

  cred=entry->firstcred;
  number=1;

  while (cred!=NULL)
  {
    if (number==cred_no) return cred;
    number++;
    cred=cred->next;
  }

  return NULL;
}
